using System;
using System.IO;
using System.Security.Permissions;
using System.Xml;
using System.Xml.Xsl;
using System.Windows.Forms;
using mshtml;

namespace TreeviewTest
{
    [PermissionSet(SecurityAction.Demand, Name = "FullTrust")]
    [System.Runtime.InteropServices.ComVisibleAttribute(true)]
    public partial class FWBTest : Form
    {
        public FWBTest()
        {
            InitializeComponent();
        }

        public void winFunction(string str)
        {
            toolStripStatusLabel1.Text = string.Format("űִз:{0}", str);
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            wb1.Document.InvokeScript("scriptFunc",
            new String[] { "winformýű" });

        }

        private void FWBTest_Load(object sender, EventArgs e)
        {
            wb1.AllowWebBrowserDrop = false;
            //wb1.IsWebBrowserContextMenuEnabled = false;
            wb1.WebBrowserShortcutsEnabled = false;
            wb1.ObjectForScripting = this;
            wb1.ScriptErrorsSuppressed = true;

            try
            {
                XslCompiledTransform xslt = new XslCompiledTransform();
                xslt.Load("rss.xslt");
                string HTMLoutput;
                using (StringWriter writer = new StringWriter())
                {
                    xslt.Transform("rss.xml", null, writer);
                    HTMLoutput = writer.ToString();
                }
                wb1.DocumentText = HTMLoutput;
            }
            catch (XsltException xsle)
            {
                Console.WriteLine("ʽд");
            }
            catch (XmlException xmle)
            {
                Console.WriteLine("ʽʱַ");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }



        private string _text = string.Empty;
        const string caretHtml = @"<span id=""caret_pos""></span>";
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            SaveDoc();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            LoadDoc();
        }
        private void NewDoc()
        {
            wb1.Navigate("about:blank");
            IHTMLDocument2 doc = wb1.Document.DomDocument as IHTMLDocument2;
            doc.designMode = "On";
        }

        private void SaveDoc()
        {
            if (wb1.Document != null)
            {
                IHTMLDocument2 doc = wb1.Document.DomDocument as IHTMLDocument2;
                HTMLDocumentClass documentClass = wb1.Document.DomDocument as HTMLDocumentClass;
                IHTMLDOMNode caret_pos = (IHTMLDOMNode)documentClass.getElementById("caret_pos");
                if (caret_pos != null) caret_pos.removeNode(true);
                IHTMLTxtRange range = doc.selection.createRange() as IHTMLTxtRange;
                range.pasteHTML(caretHtml);
                range.collapse(true);
                _text = doc.body.innerHTML;
                doc.body.innerHTML = "";
            }
        }

        private void LoadDoc()
        {
            if (!string.IsNullOrEmpty(_text))
            {
                IHTMLDocument2 doc = wb1.Document.DomDocument as IHTMLDocument2;
                doc.body.innerHTML = _text;
                IHTMLBodyElement bodyElement = doc.body as IHTMLBodyElement;
                if (bodyElement != null)
                {
                    IHTMLTxtRange range = bodyElement.createTextRange();
                    HTMLDocumentClass documentClass = wb1.Document.DomDocument as HTMLDocumentClass;
                    IHTMLElement caret_pos = documentClass.getElementById("caret_pos");
                    if (caret_pos != null)
                    {
                        range.moveToElementText(caret_pos);
                        range.select();
                    }
                }
                _text = "";
            }
        }


        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            NewDoc();
        }


    }
}